> For the complete documentation index, see [llms.txt](https://dayz.foxapo.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://dayz.foxapo.com/mods/crdtn-core/rest-api/getting-started.md).

# Getting started

Let's dive into that and create a new empty class. It depends where you would like to use this class so choose the respective module based on your case. I chose module **4\_World**

<pre class="language-csharp" data-overflow="wrap" data-line-numbers><code class="lang-csharp">class ExampleApi
{
    // Suggestion is to cache the api reference (do not create new instance for each call) 
<strong>    protected ref CRDTN_RestApiWrapper m_RestApi;
</strong>};
</code></pre>

As you can see, I just made an empty class with a cached reference to a RestApi wrapper class instance. Let's add the constructor to the class and setup the API upon the constructing our class **ExampleApi**

<pre class="language-csharp" data-overflow="wrap" data-line-numbers><code class="lang-csharp">class ExampleApi
{
    // Suggestion is to cache the api reference (do not create new instance for each call) 
<strong>    protected ref CRDTN_RestApiWrapper m_RestApi;
</strong><strong>    
</strong><strong>    void ExampleApi()
</strong><strong>    {
</strong><strong>        // https://my-backend-server
</strong><strong>        string url = ""; // Use some endpoint you need to call request on 
</strong><strong>        m_RestApi = new CRDTN_RestApiWrapper(url);
</strong><strong>    }
</strong>};
</code></pre>

#### Using GET method

{% code overflow="wrap" lineNumbers="true" fullWidth="false" %}

```csharp
// Instantiate the api instance for the URL 
autoptr CRDTN_RestApiWrapper m_RestApi = new CRDTN_RestApiWrapper("https://my-backend-server");

// Using callback events
m_RestApi.ExecuteRequest("/endpoint", "GET", "");
```

{% endcode %}

#### Using POST method

{% code fullWidth="false" %}

```csharp
RestApiResponse<string> requestData = new RestApiResponse<string>();
requestData.requestType = typename.EnumToString(RestApiRequestType, RestApiRequestType.AUTH_TEST);
requestData.uniqueId = "testUser";
string data = JsonFileLoader<RestApiResponse<string>>.JsonMakeData(requestData);
m_RestApi.ExecuteRequest("/api/auth", "POST", data);
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://dayz.foxapo.com/mods/crdtn-core/rest-api/getting-started.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
